#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

// main spawns a thread at tata, and tata spawns a thread at toto.
// main waits for toto and recovers its exit code.
// tata cannot be waited for as it detaches itself.
// Remember that exiting main kills tata, too.

pthread_t t1,t2;

void* toto (void *arg)
{
	long i = 2 * ((long) arg);
	sleep(5);
	return (void*)i;
}

void* tata (void *arg)
{
	pthread_create(&t1,NULL,toto,(void*)3);
	pthread_detach(pthread_self());
	while (1) { sleep(1); printf("dum di dum\n"); }
}

int main ()
{
	int result;
	int success;

	pthread_create(&t2,NULL,tata,NULL);
	sleep(2);
	success = pthread_join(t1,(void**)&result);
	printf("success=%d, result=%d\n",success,result);
}
